/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package main;

import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.Iterator;
import java.util.List;
import main.tools.Tools;
import messif.algorithms.AlgorithmMethodException;
import messif.algorithms.impl.ParallelSequentialScan;
import messif.objects.LocalAbstractObject;
import messif.objects.impl.ObjectFloatVectorL2;
import messif.operations.data.BulkInsertOperation;
import messif.operations.query.KNNQueryOperation;

/**
 *
 * @author xmic
 */
public class EvaluateKNNQueries {

    public static void main(String[] args) throws AlgorithmMethodException, NoSuchMethodException, FileNotFoundException {
        String queryPath = "c:\\Data\\2017\\2017_Separability\\Experiments\\SIFT\\data\\queryset-sift-1000.data";
        String dataPath = "c:\\Data\\2017\\2017_Separability\\Experiments\\SIFT\\data\\sift-1M.data";
        PrintStream ps = new PrintStream("c:\\Data\\2017\\2017_Separability\\Experiments\\SIFT\\data\\ground-truth-1000000_my.txt");
        System.setOut(ps);
        System.setErr(ps);

        String className = ObjectFloatVectorL2.class.getName();
        List<LocalAbstractObject> data = Tools.getObjects(className, dataPath);
        ParallelSequentialScan alg = new ParallelSequentialScan(8);
        BulkInsertOperation insert = new BulkInsertOperation(data);
        alg.executeOperation(insert);
        Iterator<LocalAbstractObject> queries = Tools.getIterator(className, queryPath);
        while (queries.hasNext()) {
            LocalAbstractObject query = queries.next();
            KNNQueryOperation knn = new KNNQueryOperation(query, 100);
            knn = alg.executeOperation(knn);
            Tools.printAnswer(knn, System.out, false, true);
        }
    }
}
