package main.tools.oldNotUsed;

import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.util.logging.Level;
import java.util.logging.Logger;
import main.tools.Tools;
import main.tools.Tools;
import messif.objects.util.AbstractObjectList;
import sf.hyperplaneDistanceDistribution.DistanceDistibutionToDividingLineToCsv;
import sf.hyperplaneDistanceDistribution.impl.DistanceDistributionToRandomPivotsCouplesBestHyperplaneDistanceValues;


/**
 *
 * @author xmic
 */
public class DistanceDistributionToHyperplanesExperiment {

    // args[0] file with descriptors
    // args[1] object class
    // args[2] objects to read
    public static void main(String[] args) throws IOException {
        AbstractObjectList objects = Tools.getObjects(args[1], args[0], Integer.parseInt(args[2]));
        AbstractObjectList pivots = Tools.getObjects(args[1], "c:\\Data\\2015_Doktorske\\Desc\\pivots-random-512.data", 128);
        DistanceDistibutionToDividingLineToCsv experiment = new DistanceDistributionToRandomPivotsCouplesBestHyperplaneDistanceValues(pivots, objects);
        String outputFileName = "c:\\Data\\2015_Doktorske\\2015_Sketches\\Pokusy\\Hyperplane\\DistToHyperplane\\DistanceDistribution.csv";
        OutputStream os = null;
        try {
            os = new FileOutputStream(outputFileName);
            experiment.writeDistanceDistribution(os);
        } catch (IOException ex) {
            Logger.getLogger(DistanceDistributionToHyperplanesExperiment.class.getName()).log(Level.SEVERE, null, ex);
        } finally {
            os.flush();
            os.close();
        }
    }

    public static byte[] floatToByteArrayForPrint(float f) {
        return Float.toString(f).replace(".", ",").getBytes();
    }

    public static final void writeToOS(OutputStream os, Object o, boolean newline) throws IOException {
        String s = o.toString();
        if (o instanceof Float) {
            s = s.replace(".", ",");
        }
        os.write(s.getBytes());
        if (newline) {
            os.write('\n');
        }
    }

}
