/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sf.algorithm.HWTOP_nefunckni;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.PrintStream;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;
import main.tools.Tools;
import messif.algorithms.Algorithm;
import messif.algorithms.AlgorithmMethodException;
import messif.buckets.CapacityFullException;
import messif.objects.util.RankedAbstractObject;
import messif.operations.data.BulkInsertOperation;
import messif.operations.query.KNNQueryOperation;
import messif.statistics.StatisticTimer;
import sf.objects.impl.Sketch;

/**
 *
 * @author xmic
 */
public class Main {

    static Float sum = 0f;

    public static long t1 = 0;
    public static long t2 = 0;
    public static long t3 = 0;
    public static long t4 = 0;
    public static long t5 = 0;
    public static long t6 = 0;

    public static Map<Integer, Integer> numberOfVisitedNodes = new TreeMap<>();
    public static Map<Integer, Integer> numberOfCompletelyProcessedNodes = new TreeMap<>();

    static {
        for (int i : new Integer[]{1, 2, 4, 8, 16}) {
            Main.numberOfVisitedNodes.put(i, 0);
            Main.numberOfCompletelyProcessedNodes.put(i, 0);
        }
    }

    public static void main(String[] args) throws AlgorithmMethodException, NoSuchMethodException, FileNotFoundException, CapacityFullException, InstantiationException, IOException, NullPointerException, ClassNotFoundException {
        int k = 1;
        String s = "75_25";
//                System.setOut(new PrintStream("c:\\Data\\2017\\2017_11_Sketch_processing\\sketches\\decaf\\Saved_dist_comps_oriented_per_partes_permutated\\k" + k + "\\Results_" + s + "_" + block + "_k" + k + ".csv"));
        int sketchLength = 256;

//                Algorithm alg = new ParallelSequentialScan(1);
//
        List<Sketch> data = Tools.getObjects(Sketch.class.getName(), "c:\\Data\\2016\\2016_Unbalanced_sketches\\Decaf\\" + s + "\\sketches\\" + sketchLength + "b.data");
//        List<Sketch> data = Tools.getObjects(Sketch.class.getName(), "c:\\Data\\2017\\2017_11_Sketch_processing\\sketches\\decaf\\sketches\\50_50\\oriented_for_HWT_per_partes_switched\\" + sketchLength + "b.data");
//                List<Sketch> data = Tools.getObjects(Sketch.class.getName(), "c:\\Data\\2017\\2017_11_Sketch_processing\\sketches\\cophir\\sketches\\50_50\\oriented_for_HWT\\" + sketchLength + "b.data");

        List<Sketch> queries = Tools.getObjects(Sketch.class.getName(), "c:\\Data\\2016\\2016_Unbalanced_sketches\\Decaf\\" + s + "\\sketches\\oriented_for_HWT_per_partes_switched\\queries_" + sketchLength + "b.data");
//        List<Sketch> queries = Tools.getObjects(Sketch.class.getName(), "c:\\Data\\2017\\2017_11_Sketch_processing\\sketches\\decaf\\sketches\\50_50\\oriented_for_HWT_per_partes_switched\\queries_" + sketchLength + "b.data");
//                List<Sketch> queries = Tools.getObjects(Sketch.class.getName(), "c:\\Data\\2017\\2017_11_Sketch_processing\\sketches\\cophir\\sketches\\50_50\\queries_" + sketchLength + "b.data");
        //
//        queries = data;

        //
        int levels = 5; // pocet deleni 2 ^ (n-1)
//        System.setOut(new PrintStream("c:\\Data\\2017\\2017_11_Sketch_processing\\sketches\\decaf\\Saved_dist_comps_HWTOP\\k1\\Results_" + s + "_" + (int) Math.pow(2, levels - 1) + "_k1.csv"));
        createAlg(data, sketchLength, levels);
        int counter = 0;
        RootNode rootNode = (RootNode) Algorithm.restoreFromFile("c:\\Data\\2017\\2017_11_Sketch_processing\\sketches\\decaf\\Saved_dist_comps_HWTOP\\HWTOP_" + levels + ".alg");
        rootNode.getOperationStatistics().getStatistics("OperationTime", StatisticTimer.class).reset();;
        
        t1 = 0;
        for (Sketch query : queries) {
//            if (counter == 1) {
//                break;
//            }
            KNNQueryOperation op = new KNNQueryOperation(query, k);
//                RangeQueryOperation op = new RangeQueryOperation(query, range);
            rootNode.executeOperation(op);
            Iterator<RankedAbstractObject> answer = op.getAnswer();
            while (answer.hasNext()) {
                RankedAbstractObject next = answer.next();
//                        if (next.getObject().getLocatorURI().equals(query.getLocatorURI())) {
//                            System.out.println("Achtung! The exact match on query object!");
//                        }
            }
//            System.out.println("AAA: " + op.getAnswerDistance());
            sum += op.getAnswerDistance();
//                    System.out.println(max);
            System.out.println(100 - RootNode.distCounts / 10000f);
            RootNode.distCounts = 0;
            counter++;
        }

        System.out.println("Average range: " + (sum / counter));
        t5 = rootNode.getOperationStatistics().getStatistics("OperationTime", StatisticTimer.class).get();;
        System.out.println("");
        System.out.println(t1);
        System.out.println(t2);
        System.out.println(t3);
        System.out.println(t4);
        System.out.println(t5);

        System.out.println(t6);
        System.out.println("");
        Tools.printMap(numberOfVisitedNodes);
        System.out.println("");
        Tools.printMap(numberOfCompletelyProcessedNodes);
        System.out.println("");
    }

    private static void createAlg(List<Sketch> data, int sketchLength, int levels) throws AlgorithmMethodException, NoSuchMethodException, IOException {
        RootNode rootNode = new RootNode(data, levels, -1, sketchLength);
//        Algorithm rootNode = new ParallelSequentialScan(6);
        BulkInsertOperation insert = new BulkInsertOperation(data);
        rootNode.executeOperation(insert);

//        List<Integer> numberOfObjectsInLeaves = rootNode.getNumberOfObjectsInLeaves();
//        Tools.printCollection(numberOfObjectsInLeaves, "\n");
        rootNode.storeToFile("c:\\Data\\2017\\2017_11_Sketch_processing\\sketches\\decaf\\Saved_dist_comps_HWTOP\\HWTOP_" + levels + ".alg");
        System.exit(0);
    }

}
