package sf.hyperplaneDistanceDistribution.impl;

import java.io.IOException;
import java.io.OutputStream;
import java.util.ArrayList;
import java.util.List;
import messif.objects.LocalAbstractObject;
import sf.hyperplaneDistanceDistribution.DistanceDistibutionToDividingLineToCsv;

/**
 *
 * @author xmic
 */
public class DistanceDistributionToRandomPivotsCouples extends DistanceDistibutionToDividingLineToCsv {

    public DistanceDistributionToRandomPivotsCouples(List<LocalAbstractObject> pivots, List<LocalAbstractObject> objects) {
        super(pivots, objects);
    }

    @Override
    public void writeDistanceDistribution(OutputStream os) throws IOException {
        List<LocalAbstractObject[]> pivotPairs = new ArrayList();
        for (int i = 0; i < pivots.size() - 1; i = i + 2) {
            LocalAbstractObject[] pair = new LocalAbstractObject[2];
            pair[0] = pivots.get(i);
            pair[1] = pivots.get(i + 1);
            pivotPairs.add(pair);
        }
        super.writeDistanceDistribution(os, pivotPairs);
    }

}
