/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sf.recallEstimation.integrating;

import org.apache.commons.math4.analysis.UnivariateFunction;

/**
 *
 * @author xmic
 */
public class FunctionPlotter {

    private final UnivariateFunction f;
    private final double min;
    private final double max;
    private final double step;

    public FunctionPlotter(UnivariateFunction f, double min, double max, double step) {
        this.f = f;
        this.min = min;
        this.max = max;
        this.step = step;
    }

    public void printPlot() {
        double cur = min;
        while (cur < max) {
            System.out.println(cur + ";" + f.value(cur));
            cur += step;
        }
    }

}
