/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sf.pivotAnalyzer;

import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;
import main.tools.Tools;
import messif.objects.LocalAbstractObject;
import messif.objects.impl.ObjectFloatVectorL2;

/**
 *
 * @author xmic
 */
public class EvaluateThresholdsForBallPartitioning {

    public static void main(String[] args) throws FileNotFoundException {
        String pivotsPath = "c:\\Data\\2017\\2017_Separability\\Experiments\\SIFT\\data\\sift-p2000-random_1.data";
        String dataFile = "c:\\Data\\2017\\2017_Separability\\Experiments\\SIFT\\data\\sift-1M.data";

        List<LocalAbstractObject> sampleSet = Tools.getObjects(ObjectFloatVectorL2.class.getName(), dataFile, 100000);
        Iterator<LocalAbstractObject> pivots = Tools.getIterator(ObjectFloatVectorL2.class, pivotsPath);
        System.setOut(new PrintStream("c:\\Data\\2017\\2017_Separability\\Experiments\\SIFT\\pivots_BP\\Partitioning.csv"));
        for (int i = 0; pivots.hasNext(); i++) {
            LocalAbstractObject pivot = pivots.next();
            List<Float> dists = new ArrayList<>();
            for (LocalAbstractObject obj : sampleSet) {
                dists.add(pivot.getDistance(obj));
            }
            Collections.sort(dists);
            Float median = dists.get(dists.size() / 2);
            System.out.println(pivot.getLocatorURI() + ";" + median);
            System.err.println("Processed pivot " + i);
        }
    }
}
