/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sf.pivotAnalyzer.csvPivotInfoFileProcessorImpl;

import messif.objects.LocalAbstractObject;
import sf.pivotAnalyzer.CsvPivotInfoFileProcessor;

/**
 *
 * @author Matej Kvassay <www.matejkvassay.sk>
 */
public class CsvFileBBRanges extends CsvPivotInfoFileProcessor {

    private final float[] bb25;
    private final float[] bb50;
    private final float[] bb75;

    public CsvFileBBRanges(String csvFilePath, LocalAbstractObject[] pivots, float[] bb25, float[] bb50, float[] bb75, String delimiter) {
        super(csvFilePath, false, pivots, delimiter);
        this.bb25 = bb25;
        this.bb50 = bb50;
        this.bb75 = bb75;
    }

    public CsvFileBBRanges(String csvFilePath, LocalAbstractObject[] pivots, float[] bb25, float[] bb50, float[] bb75) {
        this(csvFilePath, pivots, bb25, bb50, bb75, ";");
    }

    @Override
    protected String[] processSplitLine(String[] split, int index) {
        bb25[index] = Float.parseFloat(removeQutes(split[2]));
        bb50[index] = Float.parseFloat(removeQutes(split[3]));
        bb75[index] = Float.parseFloat(removeQutes(split[4]));
        return new String[]{split[0], split[1]};
    }
}
