package sf.pivotAnalyzer.csvPivotInfoFileProcessorImpl;

import messif.objects.LocalAbstractObject;
import sf.pivotAnalyzer.CsvPivotInfoFileProcessor;

/**
 *
 * @author xmic
 */
public class CsvFileBallRanges extends CsvPivotInfoFileProcessor{
    
    private float[] ranges;

    public CsvFileBallRanges(String csvFilePath, LocalAbstractObject[] pivots, float[] ranges, String delimiter) {
        super(csvFilePath, false, pivots, delimiter);
        this.ranges = ranges;
    }

    public CsvFileBallRanges(String csvFilePath, LocalAbstractObject[] pivots, float[] ranges) {
        this(csvFilePath, pivots, ranges, ";");
    }

    @Override
    protected String[] processSplitLine(String[] split, int index) {
        ranges[index] = Float.parseFloat(removeQutes(split[1]));
        return new String[]{split[0]};
    }

    
}
