/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package main.tools;

import java.util.List;

/**
 *
 * @author xmic
 */
public class AverageDistToKNN {

    public static void main(String[] args) {
//        String groundTruthPath = "c:\\Data\\2017\\2017_Separability\\Experiments\\Decaf\\groundtruth-profineural-1M-q1000.txt";
        String groundTruthPath = "c:\\Data\\2017\\2017_Separability\\Experiments\\SIFT\\data\\ground-truth-1000000_my.txt";
        KNNResultFileParser parser = new KNNResultFileParser(groundTruthPath);
        List<KNNResultFileParser.EvaluatedQuery> groundTruth = parser.getEvaluatedQueries();
        int[] ks = new int[]{1, 10, 100};
        float[] sums = new float[ks.length];
        for (KNNResultFileParser.EvaluatedQuery result : groundTruth) {
            List<Float> dists = result.getDistances();
            for (int i = 0; i < sums.length; i++) {
                sums[i] += dists.get(ks[i] - 1);
            }
        }
        for (int i = 0; i < sums.length; i++) {
            sums[i] = sums[i] / groundTruth.size();
        }
        System.out.println("\n\n\n");
        Tools.printArray(sums, "\n");
        System.out.println("\n\n\n");
    }
}
