/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package main.tools;

import java.util.List;
import java.util.Map;
import java.util.TreeMap;

/**
 *
 * @author xmic
 */
public class DistancesToKNNForDifferentQueriesDistribution {

    public static void main(String[] args) {
//        String groundTruthPath = "c:\\Data\\2017\\Secondary_filtering\\ground_truth_filtered\\groundtruth-1M-q1000.txt";
        String groundTruthPath = "c:\\Data\\2016\\Filtrovani_MIndexu\\Cophir\\groundtruth-1M-q1000.txt";
        int k = 10;
        float interval = 0.02f;
        KNNResultFileParser groundTruth = new KNNResultFileParser(groundTruthPath);
        List<KNNResultFileParser.EvaluatedQuery> evaluatedQueries = groundTruth.getEvaluatedQueries();
        Map<Float, Integer> numberOfDistances = new TreeMap<>();
        for (KNNResultFileParser.EvaluatedQuery evaluatedQuery : evaluatedQueries) {
            float dist = evaluatedQuery.getDistances().get(k);
            int div = (int) (dist / interval);
            dist = div * interval;
            if (!numberOfDistances.containsKey(dist)) {
                numberOfDistances.put(dist, 1);
            } else {
                Integer get = numberOfDistances.get(dist);
                numberOfDistances.put(dist, get + 1);
            }
        }
        Tools.printMap(numberOfDistances);
    }

}
