/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package main.tools;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintStream;

/**
 *
 * @author xmic
 */
public class EvaluateRecallOfSketchFilteringMain {

    public static void main(String[] args) throws FileNotFoundException {
//        System.setOut(new PrintStream("c:\\Data\\2017\\2017_Separability\\Experiments\\SIFT\\Plotly_data_100, 500, 1000, 2000, 4000, 5000.csv"));
//        String groundTruthPath = "c:\\Data\\2017\\2017_Separability\\Experiments\\SIFT\\data\\ground-truth-1000000_my.txt";
//        File folderWithSketchesData = new File("c:\\Data\\2017\\2017_Separability\\Experiments\\SIFT\\Sketches\\");

        System.setOut(new PrintStream("c:\\Data\\2017\\2017_Separability\\Experiments\\Decaf\\Plotly_data_100, 500, 1000, 2000, 4000, 5000.csv"));
        String groundTruthPath = "c:\\Data\\2017\\2017_Separability\\Experiments\\Decaf\\groundtruth-profineural-1M-q1000.txt";
        File folderWithSketchesData = new File("c:\\Data\\2017\\2017_Separability\\Experiments\\Decaf\\Sketches\\");
//        System.setOut(new PrintStream("c:\\Data\\2017\\2017_11_Sketch_processing\\HWT_C_moje\\data\\SQFD\\Recall\\SeqScan_GHP.csv"));
//        String groundTruthPath = "c:\\Data\\2017\\2017_11_Sketch_processing\\HWT_C_moje\\data\\SQFD\\ground-truth-1M_SQFD_concat_part1_orig_part2.txt";
//        File folderWithSketchesData = new File("c:\\Data\\2017\\2017_11_Sketch_processing\\HWT_C_moje\\data\\SQFD\\Sketches\\");
        File[] sketchesData = folderWithSketchesData.listFiles((File dir, String name) -> name.endsWith(".data")
                && (name.contains("64") || name.contains("128") || name.contains("192") || name.contains("256"))
                && (name.contains("GHP_50") || name.contains("GHP_80") || name.contains("BP_50") || name.contains("THRR_50") || name.contains("NSP_50"))
        );
//        File[] sketchesData = folderWithSketchesData.listFiles((File dir, String name) -> name.endsWith(".data") && (name.contains("GHP")));
//        int[] candSetSizes = new int[]{100, 200, 500, 1000, 2000, 5000, 10000}; // adbis 2000
        int[] candSetSizes = new int[]{100}; // adbis 2000
        int k = 100;
        for (File sketches : sketchesData) {
            System.gc();
            String sketchesQueries = sketches.getParentFile().getParent() + "\\Queries_sketches\\" + sketches.getName();
            if (!new File(sketchesQueries).exists()) {
                System.err.println("File does not exist: " + sketchesQueries);
                continue;
            }
            EvaluateRecallOfSketchFiltering evaluator = new EvaluateRecallOfSketchFiltering(groundTruthPath, sketches.getAbsolutePath(), sketchesQueries);
            System.out.println(sketches.getAbsolutePath() + ";");
            float[] recall = evaluator.evaluateAverageRecall(k, candSetSizes);
//            Tools.printArray(recall, ";");
            System.out.println();
        }
    }
}
