/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package main.tools;

import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.Map;
import messif.objects.LocalAbstractObject;
import messif.objects.impl.ObjectFloatVectorL2;
import messif.objects.util.AbstractObjectList;
import sf.pivotAnalyzer.PivotsForVoronoiSketchesSelector;

/**
 *
 * @author xmic
 */
public class FindPivotsForVoronoiSketches {

    public static void main(String[] args) throws FileNotFoundException {
        String pivotsFile = "c:\\Data\\2015_Doktorske\\Desc\\profiset\\caffe\\pivots-random-512.data";
//        String objFile = "c:\\Data\\2015_Doktorske\\Desc\\profiset\\caffe\\pivots-random-512.data";
        String objFile = "c:\\Data\\2015_Doktorske\\Desc\\profiset\\caffe\\profi-neuralnet-100K.data.gz";
//        String objFile = "c:\\Data\\2015_Doktorske\\Desc\\profiset\\caffe\\profi-neuralnet-1M.data.gz";
        String clazz = ObjectFloatVectorL2.class.getName();

        AbstractObjectList pivots = Tools.getObjects(clazz, pivotsFile);
        AbstractObjectList objects = Tools.getObjects(clazz, objFile);

        for (int i = 1; i < 18; i++) {
            System.setOut(new PrintStream("c:\\Data\\2017\\2017_Voronoi_Sketches\\shuffle_pivots\\" + i + "_Pivots_100000obj_512p.txt"));
            System.setErr(new PrintStream("c:\\Data\\2017\\2017_Voronoi_Sketches\\shuffle_pivots\\" + i + "_Pivots_err_100000obj_512p.txt"));

            PivotsForVoronoiSketchesSelector selector = new PivotsForVoronoiSketchesSelector(objects, pivots);
            Map<String, LocalAbstractObject> analysedPivots = selector.analysePivots();
            PivotsForVoronoiSketchesSelector.printPivots(analysedPivots);
        }

    }
}
