/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package main.tools;

import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.Iterator;
import java.util.Map;
import java.util.logging.Level;
import java.util.logging.Logger;
import messif.objects.LocalAbstractObject;
import messif.objects.impl.ObjectSignatureSQFD;
import messif.objects.util.AbstractObjectList;
import messif.objects.util.StreamGenericAbstractObjectIterator;

/**
 *
 * @author xmic
 */
public class MatrixOfDistances {
    
    public static final String DELIMITER = ";";
    public static final Integer ROWS = 100000000;
    
    public static void main(String[] args) throws FileNotFoundException {
        String preffix = "c:\\Data\\2017\\2017_11_Sketch_processing\\HWT_C_moje\\data\\SQFD\\";
        String suffix1 = "queryset-sqfd-1000";//"profimedia-1M";
        String suffix2 = "pivots-reallyrandom-65536";
//        suffix1 = suffix2;
        String file1 = preffix + suffix1 + ".data";
        String file2 = preffix + suffix2 + ".data";
        
        System.setOut(new PrintStream("c:\\Data\\2017\\2017_11_Sketch_processing\\HWT_C_moje\\data\\SQFD\\Dists_" + suffix1 + "_" + suffix2 + ".csv"));
        
        StreamGenericAbstractObjectIterator it1 = Tools.getIterator(ObjectSignatureSQFD.class.getName(), file1);
        AbstractObjectList list2 = Tools.getObjects(ObjectSignatureSQFD.class.getName(), file2, 512);
        
        System.out.print("Columns: " + suffix2 + ", Rows: " + suffix1 + DELIMITER);
        Iterator<LocalAbstractObject> it2 = list2.iterator();
        while (it2.hasNext()) {
            LocalAbstractObject e2 = it2.next();
            String locator2 = e2.getLocatorURI();
            System.out.print(locator2 + DELIMITER);
        }
        System.out.println();
        
        for (int counter = 0; counter < ROWS && it1.hasNext(); counter++) {
            LocalAbstractObject obj1 = it1.next();
            String locator1 = obj1.getLocatorURI();
            System.out.print(locator1 + DELIMITER);
            it2 = list2.iterator();
            while (it2.hasNext()) {
                LocalAbstractObject e2 = it2.next();
                System.out.print(obj1.getDistance(e2) + DELIMITER);
            }
            if (counter % 1000 == 0) {
                Logger.getLogger(MatrixOfDistances.class.getName()).log(Level.INFO, "Processed {0} rows", counter);
            }
            System.out.println();
        }
    }
}
