/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package main.tools;

import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.Iterator;
import java.util.SortedMap;
import main.SketchCardinalitiesCounter;
import sf.objects.impl.Sketch;

/**
 *
 * @author xmic
 */
public class PrintSketchCardinalities {

    public static void main(String[] args) throws FileNotFoundException {
        int[] sizes = new int[]{32, 64, 128, 205, 256};
//        int[] sizes = new int[]{205, 256};
        for (int size : sizes) {
            String s = "80_20";
//            String filePathWithSketches = "c:\\Data\\2016_orientedSketches\\DeCAF_Profiset\\Orientace_dle_outlier_0000028271\\" + size + "b.txt";
//            String filePathWithSketches = "c:\\Data\\2016\\2016_Unbalanced_sketches\\Decaf\\" + s + "\\sketches\\oriented_for_HWT\\" + size + "b.data";
            String filePathWithSketches = "c:\\Data\\2016\\2016_Unbalanced_sketches\\Decaf\\" + s + "\\sketches\\oriented\\" + size + "b.data";

            printCardinalities(filePathWithSketches);
//            printCardinalities("c:\\Data\\2016\\2016_Unbalanced_sketches\\Decaf\\85_15\\sketches\\queries_256b.data");
//            printSketches("c:\\Data\\2017\\2017_Separability\\Experiments\\Decaf\\OrientedSketches\\GHP_80_20_256b.data");
        }
    }

    public static void printSketches(String path) throws FileNotFoundException {
        int length = 256;
        Iterator<Sketch> it = Tools.getIterator(Sketch.class, path);
        try (PrintStream printStream = new PrintStream(path + "_sketches")) {
            System.setOut(printStream);
            int counter = 0;
            while (it.hasNext() && counter < 10000) {
                counter++;
                Sketch next = it.next();
                System.out.print(next.getLocatorURI() + ";");
                for (int i = 0; i < length; i++) {
                    int intValue;
                    if (next.getBitValue(i)) {
                        intValue = 1;
                    } else {
                        intValue = 0;
                    }
                    System.out.print(intValue + ";");
                }
                System.out.println();
            }
            printStream.flush();
        }
    }

    public static void printCardinalities(String path) throws FileNotFoundException {
        Iterator<Sketch> it = Tools.getIterator(Sketch.class, path);
        try (PrintStream printStream = new PrintStream(path + "_cards")) {
            System.setOut(printStream);
            SortedMap<Integer, Integer> cardinalities = SketchCardinalitiesCounter.evaluate(it);
            for (int i = 0; i < cardinalities.lastKey(); i++) {
                if (cardinalities.containsKey(i)) {
                    System.out.println(i + ";" + cardinalities.get(i));
                } else {
                    System.out.println(i + ";0");
                }
            }
            printStream.flush();
        }
    }

}
