/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package main.tools;

import java.io.FileNotFoundException;
import main.tools.oldNotUsed.SketchFromAlgorithmToFile;
import java.io.IOException;
import java.io.PrintStream;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import messif.objects.AbstractObject;
import messif.objects.LocalAbstractObject;
import messif.objects.impl.ObjectFloatVectorNeuralNetworkL2;
import messif.objects.util.AbstractObjectList;
import messif.objects.util.StreamGenericAbstractObjectIterator;
import sf.objects.impl.Sketch;
import sf.objects.sketchcreator.ObjectToSketchTransformator;
import sf.objects.sketchcreator.impl.BalancedBitsBySomePositionsComparing;
import sf.objects.sketchcreator.impl.BallPartitioning;
import sf.objects.sketchcreator.impl.GenHyperplane;

/**
 *
 * @author xmic
 */
public class TransformObjectsToSketches {

    public static void main(String[] args) throws IOException {
//        completeWithPivotAnalysis(args);
        withAnalysedPivots(args);
    }

//    private static final int[] switchBits = new int[]{0, 0, 0, 0, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, 1, 0, 1, 1, 0, 0, 0, 1, 0, 0, 1, 0, 1, 0, 1, 1, 0, 1, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 1, 0, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 1, 0, 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 1, 0, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, 0, 1, 1, 1, 0, 1, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 0, 1, 1, 1, 0, 0, 1};
    public static void withAnalysedPivots(String[] args) throws IOException {

        String dataToTransform = args[0];
        String csvFile = args[1];
        String destPath = args[2];
        int sketchSize = Integer.parseInt(args[3]);
        String pivotFile = args[4];
        String className = args[5];

        //
//        String dataToTransform = "c:\\Data\\2015_Doktorske\\Desc\\cophir\\mpeg7\\queryset-cophir-1000_sapir2.data";
//        String dataToTransform = "c:\\Data\\2015_Doktorske\\Desc\\cophir\\mpeg7\\1M\\metaobject.data.gz";
//        String dataToTransform = "c:\\Data\\2015_Doktorske\\Desc\\profiset\\caffe\\profi-neuralnet-1000-query.data";
//        String dataToTransform = "c:\\Data\\2017\\2017_Separability\\Experiments\\SIFT\\data\\queryset-sift-1000.data";
//        String dataToTransform = "c:\\Data\\2015_Doktorske\\Desc\\profiset\\caffe\\profi-neuralnet-1M.data.gz";
//        String dataToTransform = "c:\\Data\\2015_Doktorske\\Desc\\profiset\\caffe\\profi-neuralnet-100K.data.gz";
//        String csvFile = "c:\\Data\\2015_Doktorske\\Desc\\profiset\\caffe\\pivots_filtered_hyperplane\\2560_random\\Correct\\UncorrelatedPivots_" + sketchSize + "_pairs.csv";
//        String s = "80_20";
//        String csvFile = "c:\\Data\\2015_Doktorske\\Desc\\cophir\\mpeg7\\pivots_filtered_hyperplane\\2560_random\\Correct\\UncorrelatedPivots_" + sketchSize + "_pairs.csv";
//        String csvFile = "c:\\Data\\2017\\2017_Separability\\Experiments\\SIFT\\pivots_GHP_50\\" + sketchSize + ".csv";
//        String csvFile = "c:\\Data\\2016\\2016_Unbalanced_sketches\\Decaf\\80_20\\pivots\\UncorrelatedPivots_" + sketchSize + "_pairs.csv";
//        String csvFile = "c:\\Data\\2017\\2017_11_Sketch_processing\\sketches\\SIFT\\sketches\\50_50\\UncorrelatedPivots_" + sketchSize + "_pairs.csv";
//        String csvFile = "c:\\Data\\2015_Doktorske\\Desc\\profiset\\caffe\\pivots_ball_partitioning\\128_outliers.csv";
//        String csvFile = "c:\\Data\\2015_Doktorske\\Desc\\profiset\\caffe\\pivots_filtered_hyperplane\\2560_random\\Correct\\UncorrelatedPivots_192_pairs.csv";
//        String csvFile = "c:\\Data\\2017\\2017_Voronoi_Sketches\\Pivots_100000obj_512p.txt";
//        String[] csvFiles = new String[]{
//            "c:\\Data\\2017\\2017_Voronoi_Sketches\\shuffle_pivots\\0_Pivots_100000obj_512p.txt",
//            "c:\\Data\\2017\\2017_Voronoi_Sketches\\shuffle_pivots\\1_Pivots_100000obj_512p.txt",
//            "c:\\Data\\2017\\2017_Voronoi_Sketches\\shuffle_pivots\\2_Pivots_100000obj_512p.txt",
//            "c:\\Data\\2017\\2017_Voronoi_Sketches\\shuffle_pivots\\3_Pivots_100000obj_512p.txt"
//        };
//        String pivotFile = "c:\\Data\\2015_Doktorske\\Desc\\cophir\\mpeg7\\pivots-2560-random.data";
//        String pivotFile = "c:\\Data\\2015_Doktorske\\Desc\\profiset\\caffe\\pivots-random-2560.data";
//        String pivotFile = "c:\\Data\\2017\\2017_Separability\\Experiments\\SIFT\\data\\sift-p2000-random_1.data";
//        String pivotFile = "c:\\Data\\2015_Doktorske\\Desc\\profiset\\caffe\\pivots-outliers-2560.data";
//        String dataForOutlier = "c:\\Data\\2015_Doktorske\\Desc\\profiset\\caffe\\profi-neuralnet-1M.data.gz";
//        String className = ObjectFloatVectorL2.class.getName();
//        String className = MetaObjectSAPIRWeightedDist2.class.getName();
//        String destPath = "c:\\Data\\2017\\2017_Separability\\Experiments\\Decaf\\Queries_sketches\\GHP_50ch_" + sketchSize + ".data";
//        String destPath = "c:\\Data\\2017\\2017_Separability\\Experiments\\SIFT\\Queries_sketches\\GHP_50_" + sketchSize + ".data";
//        String destPath = "c:\\Data\\2017\\2017_11_Sketch_processing\\sketches\\decaf\\sketches\\50_50\\queries_" + sketchSize + "b.data";
//        String destPath = "c:\\Data\\2017\\2017_11_Sketch_processing\\sketches\\cophir\\sketches\\" + s + "\\queries_" + sketchSize + "b.data";
//        String destPath = "c:\\Data\\2017\\2017_Voronoi_Sketches\\sketches\\sketches100K_pivots_100000obj_512p.data";
//        String dataToTransform = "c:\\Data\\2015_Doktorske\\Desc\\cophir\\mpeg7\\1M\\metaobject.data.gz";
//        String dataToTransform = "c:\\Data\\2015_Doktorske\\Desc\\cophir\\mpeg7\\queryset-cophir-1000.data";
//        String csvFileWithPivotsPairs = "c:\\Data\\2015_Doktorske\\Desc\\cophir\\mpeg7\\pivots_filtered_hyperplane\\2560_random\\Correct\\UncorrelatedPivots_" + sketchSize + "_pairs.csv";
//        String pivotFile = "c:\\Data\\2015_Doktorske\\Desc\\cophir\\mpeg7\\pivots-2560-random.data";
//        String className = MetaObjectSAPIRWeightedDist3.class.getName();
//        String className = ObjectFloatVectorCosine.class.getName();
//        String destPath = "c:\\Data\\2017\\Secondary_filtering\\Journal_experiments\\Cophir\\Sketches\\" + sketchSize + "b.data";
        ObjectToSketchTransformator tr = new GenHyperplane(pivotFile, className, sketchSize, csvFile, false);
//        ObjectToSketchTransformator tr = new BallPartitioning(pivotFile, className, sketchSize, csvFile, false);
//        LocalAbstractObject outlier = Tools.getObject(dataForOutlier, "0000028271", className);
//        tr.reorderPivotsByOutlier(outlier);
//        tr.reorderPivotsToSwitchBits(switchBits);
        StreamGenericAbstractObjectIterator dataIt = Tools.getIterator(className, dataToTransform);
        PrintStream ps = null;
        try {
            ps = new PrintStream(destPath);
            int counter = 0;
            while (dataIt.hasNext()) {
                LocalAbstractObject lao = dataIt.next();
                Sketch sketch = tr.transform(lao);
                sketch.write(ps);
                counter++;
                if (counter % 10000 == 0) {
                    System.gc();
                    Logger.getLogger(TransformObjectsToSketches.class.getName()).log(Level.INFO, "Tranformed {0} objects.", counter);
                }
            }
        } catch (IOException ex) {
            Logger.getLogger(SketchFromAlgorithmToFile.class.getName()).log(Level.SEVERE, null, ex);
        } finally {
            ps.flush();
        }

    }

    public static void completeWithPivotAnalysis(String[] args) throws IOException {
        String dataFilePath = args[0];
        String csvResultPath = args[1];
        String destPath = args[2];
        int finalSketchSize = Integer.parseInt(args[3]);
        String pivotFile = args[4];
        float balance = Float.parseFloat(args[5]);
        String className = args[6];

//        String pivotFile = "c:\\Data\\2015_Doktorske\\Desc\\cophir\\mpeg7\\pivots-512-random.data";
//        String pivotFile = "c:\\Data\\2015_Doktorske\\Desc\\profiset\\caffe\\pivots-random-2560.data";
//        String pivotFile = "c:\\Data\\2017\\2017_Separability\\Experiments\\SIFT\\data\\sift-p2000-random_1.data";
//        int size = 64;
//        String pivotFile = "c:\\Data\\2017\\2017_11_Sketch_processing\\HWT_C_moje\\data\\SQFD\\pivots-reallyrandom-65536.data";
//        String dataFilePath = "c:\\Data\\2017\\2017_11_Sketch_processing\\HWT_C_moje\\data\\SQFD\\profimedia-1M.data";
//        String csvResultPath = "c:\\Data\\2017\\2017_11_Sketch_processing\\HWT_C_moje\\data\\SQFD\\pivots_"+ size + ".csv";
//        String destPath = "c:\\Data\\2017\\2017_11_Sketch_processing\\HWT_C_moje\\data\\SQFD\\GHP_50_" + size + ".csv";
//        String dataFilePath = "c:\\Data\\2015_Doktorske\\Desc\\profiset\\caffe\\profi-neuralnet-1M.data.gz";
//        String dataFilePath = "c:\\Data\\2017\\2017_Separability\\Experiments\\SIFT\\data\\sift-1M.data";
//        String dataFilePath = "c:\\Data\\2015_Doktorske\\Desc\\cophir\\mpeg7\\1M\\metaobject.data.gz";
//        completeWithPivotAnalysis(pivotFile, dataFilePath, 64);
        completeWithPivotAnalysis(pivotFile, csvResultPath, dataFilePath, destPath, finalSketchSize, balance, className);
    }

    private static void completeWithPivotAnalysis(String pivotFile, String csvResultPath, String dataFilePath, String destPath, int finalSketchSize, float balance, String className) throws FileNotFoundException, IOException {
        int sampleSetSize = 20000; 
        int numberOfBalanced = 15000; //15000
//        String csvResultPath = "c:\\Data\\2015_Doktorske\\Desc\\profiset\\pivots_ball_partitioning\\" + finalSketchSize + "_outliers.csv";
//        String csvResultPath = "c:\\Data\\2015_Doktorske\\Desc\\profiset\\caffe\\pivots_filtered_hyperplane\\2560_random\\Correct\\UncorrelatedPivots_" + finalSketchSize + "_pairs.csv";
//        String csvResultPath = "c:\\Data\\2016\\2016_Unbalanced_sketches\\Decaf\\80_20\\pivots\\UncorrelatedPivots_192_pairs.csv";
//        String csvResultPath = "c:\\Data\\2017\\2017_Separability\\Experiments\\SIFT\\pivots_GHP_80\\" + finalSketchSize + ".csv";
//        String destPath = "c:\\Data\\2017\\2017_Separability\\Experiments\\Decaf\\Sketches\\GHP_80_" + finalSketchSize + ".data";
//        String destPath = "c:\\Data\\2017\\2017_Separability\\Experiments\\SIFT\\Sketches\\GHP_80_" + finalSketchSize + ".data";
//        String className = ObjectFloatVectorL2.class.getName();
//        String pivotFile = "c:\\Data\\2016_Lucia\\NoRelu_SeZapornymiHodnotami\\Desc_orig\\PCA\\512\\MIRFlickr_hybridCNN_gmean_noReLu_fc6-PCA-512dim-CNN.messif";
//        String dataFilePath = "c:\\Data\\2016_Lucia\\NoRelu_SeZapornymiHodnotami\\Desc_orig\\PCA\\512\\PCA-512dim-CNN.messif.txt";
//        String destPath = "c:\\Data\\2016_Lucia\\NoRelu_SeZapornymiHodnotami\\Desc_orig\\PCA\\512\\Sketches_256_PCA-512dim-CNN.messif.txt";
//        String className = ObjectFloatVectorNeuralNetworkL2.class.getName();

        System.setOut(new PrintStream(csvResultPath));
        StreamGenericAbstractObjectIterator dataIt = Tools.getIterator(className, dataFilePath);
        List<LocalAbstractObject> sampleObjects = new AbstractObjectList<>(dataIt, sampleSetSize);
        dataIt.reset();

        ObjectToSketchTransformator tr = new GenHyperplane(pivotFile, className, 256, true);
//        ObjectToSketchTransformator tr = new BallPartitioning(pivotFile, className, 2000, "c:\\Data\\2017\\2017_Separability\\Experiments\\SIFT\\pivots_BP\\Partitioning.csv", true);
        tr.transformAllObjectsToSketchesComplete(dataIt, sampleObjects, balance, finalSketchSize, numberOfBalanced, destPath);
        System.out.flush();
    }

    @Deprecated
    private static void directly(String[] args) throws IOException {
//        String dataFilePath = args[0];
//        String destPath = args[1];
//        int finalSketchSize = Integer.parseInt(args[2]);
//        String className = ObjectFloatVectorNeuralNetworkL2.class.getName();

        int finalSketchSize = 256;
        String dataFilePath = "c:\\Data\\2016_Lucia\\NoRelu_SeZapornymiHodnotami\\Desc_orig\\Data_INRIAHolidays_hybridCNN_gmean_noReLu_fc6.messif.txt";
        String destPath = "c:\\Data\\2016_Lucia\\NoRelu_SeZapornymiHodnotami\\Desc_sketches\\RawComparingPairsWithMaxMean_" + finalSketchSize + "_INRIAHolidays_hybridCNN_gmean_noReLu_fc6.messif.txt";
        String className = ObjectFloatVectorNeuralNetworkL2.class.getName();
        System.setOut(new PrintStream("c:\\Data\\2016_Lucia\\NoRelu_SeZapornymiHodnotami\\Pivots\\UncorrelatedPivots_" + finalSketchSize + "_pairs.csv"));
        int[] vectorPositions = makeVectorPositions();
        ObjectToSketchTransformator tr = new BalancedBitsBySomePositionsComparing(vectorPositions);
        StreamGenericAbstractObjectIterator dataIt = Tools.getIterator(className, dataFilePath);
        List<LocalAbstractObject> sampleObjects = new AbstractObjectList<>(dataIt);
        dataIt.reset();

        List<AbstractObject> ret = tr.transformAllObjectsToSketchesComplete(dataIt, sampleObjects, 0.45f, finalSketchSize, 20000, null);
        Tools.save(ret.iterator(), destPath);
    }

    @Deprecated
    private static int[] makeVectorPositions() {
        String s = "3628.0;2287.0;497.0;488.0;464.0;788.0;261.0;3605.0;2566.0;3798.0;87.0;304.0;2504.0;2172.0;2070.0;499.0;3041.0;2381.0;828.0;1488.0;3964.0;1535.0;3420.0;55.0;2094.0;588.0;2151.0;3760.0;3238.0;3389.0;878.0;3998.0;182.0;711.0;3222.0;819.0;3526.0;774.0;3111.0;3627.0;2258.0;3069.0;2707.0;226.0;3513.0;2333.0;2922.0;1623.0;583.0;3885.0;1963.0;2564.0;241.0;3475.0;3082.0;2215.0;1698.0;1486.0;2345.0;1052.0;3027.0;2240.0;581.0;1633.0;3030.0;1367.0;1270.0;465.0;3164.0;1236.0;1926.0;2494.0;2975.0;1745.0;1340.0;3925.0;1558.0;4052.0;1938.0;870.0;2388.0;3538.0;2946.0;1787.0;1004.0;3536.0;4044.0;3333.0;894.0;4028.0;3713.0;3749.0;1883.0;3183.0;1097.0;1438.0;3428.0;344.0;1675.0;436.0;3424.0;2251.0;3840.0;4022.0;280.0;17.0;1856.0;3596.0;2663.0;1144.0;1936.0;1499.0;3899.0;1380.0;3003.0;2016.0;2409.0;3656.0;1529.0;2516.0;1906.0;1036.0;1584.0;298.0;471.0;3432.0;764.0;2936.0;784.0;3155.0;3700.0;2245.0;2020.0;90.0;2018.0;1192.0;3930.0;1074.0;2450.0;1072.0;476.0;3500.0;3670.0;1206.0;2097.0;2891.0;637.0;2029.0;1813.0;2982.0;1770.0;427.0;1615.0;240.0;435.0;1571.0;1872.0;882.0;1196.0;4027.0;3821.0;1040.0;1400.0;467.0;814.0;42.0;1113.0;1690.0;3383.0;59.0;2474.0;3517.0;2536.0;3989.0;146.0;1547.0;3084.0;1838.0;1209.0;2249.0;1139.0;4033.0;1029.0;3823.0;328.0;1768.0;1148.0;3578.0;1673.0;3833.0;29.0;3520.0;3742.0;3508.0;560.0;3983.0;2646.0;1301.0;3417.0;3282.0;2338.0;2637.0;988.0;3638.0;2604.0;3297.0;1145.0;3904.0;2966.0;2447.0;578.0;308.0;1793.0;553.0;3195.0;656.0;78.0;2212.0;2876.0;1864.0;840.0;1241.0;2576.0;2025.0;3456.0;664.0;2001.0;811.0;2734.0;2791.0;1761.0;2438.0;3763.0;83.0;1991.0;3099.0;67.0;2757.0;207.0;785.0;879.0;3810.0;116.0;2778.0;4012.0;2553.0;2961.0;3699.0;2218.0;1971.0;3309.0;2597.0;152.0;132.0;3676.0;1731.0;3528.0;21.0;1227.0;1614.0;4066.0;1812.0;1909.0;402.0;3211.0;170.0;1538.0;2113.0;3435.0;306.0;2993.0;3051.0;3032.0;3666.0;2517.0;3259.0;3851.0;1455.0;3837.0;1390.0;1028.0;1683.0;407.0;2163.0;2047.0;3950.0;1980.0;2606.0;30.0;2178.0;4080.0;759.0;3059.0;3963.0;444.0;2853.0;2241.0;2186.0;1473.0;3477.0;3491.0;1125.0;1363.0;500.0;150.0;1509.0;2660.0;1041.0;1069.0;545.0;2354.0;2037.0;1092.0;3251.0;1103.0;31.0;1141.0;2952.0;2930.0;2317.0;1915.0;3101.0;3524.0;2848.0;479.0;3250.0;4095.0;1803.0;252.0;1457.0;421.0;862.0;3953.0;1184.0;605.0;537.0;2373.0;2132.0;390.0;3868.0;3305.0;2926.0;3552.0;2591.0;2154.0;2811.0;990.0;2977.0;1154.0;1773.0;3371.0;3128.0;921.0;4005.0;726.0;369.0;1026.0;419.0;3618.0;3223.0;342.0;4046.0;1210.0;3860.0;1450.0;3269.0;2171.0;1213.0;3338.0;4000.0;2394.0;3654.0;2361.0;3037.0;3490.0;2007.0;2006.0;4.0;775.0;1597.0;1466.0;3310.0;237.0;635.0;2735.0;2507.0;292.0;2103.0;1616.0;3018.0;3876.0;3732.0;2402.0;1379.0;2061.0;1310.0;3312.0;571.0;1799.0;115.0;1709.0;3019.0;1967.0;1174.0;558.0;2890.0;2304.0;3217.0;3955.0;3484.0;2974.0;4004.0;2074.0;3882.0;462.0;2385.0;3862.0;3181.0;2549.0;2720.0;3911.0;3707.0;1778.0;3496.0;3881.0;778.0;3942.0;2860.0;1981.0;2146.0;2822.0;9.0;511.0;2526.0;1896.0;3157.0;3040.0;1517.0;3448.0;1344.0;2306.0;3382.0;959.0;2112.0;3202.0;178.0;3102.0;2752.0;1902.0;1121.0;2301.0;504.0;584.0;557.0;2627.0;906.0;1687.0;3255.0;3247.0;2589.0;2607.0;3891.0;3896.0;1370.0;228.0;1161.0;2155.0;2872.0;395.0;2395.0;1491.0;56.0;1533.0;1522.0;3004.0;63.0;1374.0;1949.0;4083.0;1095.0;3770.0;2469.0;846.0;548.0;3118.0;2943.0;1934.0;3784.0;3439.0;2164.0;3717.0;1347.0;2500.0;387.0;2117.0;1604.0;2446.0;288.0;3401.0;2582.0;3129.0;875.0;2107.0;2234.0;2226.0;299.0;2672.0;823.0;3816.0;3719.0;246.0;4065.0;";
        int length = 512;
        String[] split = s.split(".0;");
        int[] ret = new int[length];
        for (int i = 0; i < length; i++) {
            ret[i] = Integer.parseInt(split[i]);
        }
        return ret;
    }
}
