/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package main.tools.oldNotUsed;

import java.io.IOException;
import java.io.PrintStream;
import java.util.Iterator;
import java.util.logging.Level;
import java.util.logging.Logger;
import main.tools.Tools;
import static main.KNNApproxEvaluation.restoreAlgorithm;
import messif.objects.AbstractObject;
import messif.objects.LocalAbstractObject;
import messif.operations.AnswerType;
import messif.operations.query.GetAllObjectsQueryOperation;
import sf.algorithm.SketchAlgorithmWithRefinement;

/**
 *
 * @author xmic
 */
public class SketchFromAlgorithmToFile {

    public static final String storagePrefix = "c:\\Data\\2015_Doktorske\\Desc\\";

    // args[0] alg path
    // args[1] dest path
    public static void main(String[] args) {
        storeSketchesFromAlgorithm(args[0], args[1]);
//        storeSketchesFromAlgorithm(storagePrefix + "indexes\\1M_asymmetric\\serialized\\SketchAlg.alg", storagePrefix + "SketchesTmp.txt");
//        Iterator it = PivotSelector.getIterator(Sketch.class.getName(), storagePrefix + "SketchesTmp.txt");
//        save(it, storagePrefix + "SketchesTmp2.txt");
    }

    @SuppressWarnings("FinalizeCalledExplicitly")
    public static void storeSketchesFromAlgorithm(String algStorePath, String destPath) {
        try {
            SketchAlgorithmWithRefinement sketchAlgorithm = (SketchAlgorithmWithRefinement) restoreAlgorithm(algStorePath);
            sketchAlgorithm.printAlgorithmInfo();
            GetAllObjectsQueryOperation op = new GetAllObjectsQueryOperation(AnswerType.ORIGINAL_OBJECTS);
            op = sketchAlgorithm.executeOperation(op);
            Iterator<AbstractObject> it = op.getAnswer();
            Tools.save(it, destPath);
            sketchAlgorithm.finalize();
            System.exit(0);
        } catch (Throwable ex) {
            Logger.getLogger(SketchFromAlgorithmToFile.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

}
