/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sf.algorithm.HWTOP;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.PrintStream;
import java.util.Iterator;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import main.tools.Tools;
import messif.algorithms.Algorithm;
import messif.algorithms.AlgorithmMethodException;
import messif.buckets.CapacityFullException;
import messif.objects.util.RankedAbstractObject;
import messif.operations.data.BulkInsertOperation;
import messif.operations.query.KNNQueryOperation;
import messif.statistics.StatisticTimer;
import sf.objects.impl.Sketch;

/**
 *
 * @author xmic
 */
public class Main {

    static Float sum = 0f;

    public static long t1 = 0;
    public static long t2 = 0;
    public static long t3 = 0;
    public static long t4 = 0;
    public static long t5 = 0;
    public static long t6 = 0;

    public static void main(String[] args) throws AlgorithmMethodException, NoSuchMethodException, FileNotFoundException, CapacityFullException, InstantiationException, IOException, NullPointerException, ClassNotFoundException {
        // data, levels, delkaSketche, cestaProAlg
        createAlg(args);
//        onLocalHost();
    }

    private static HWTOPAlgorithm createAlg(List<Sketch> data, int sketchLength, int levels, String s) throws AlgorithmMethodException, NoSuchMethodException, IOException {
        HWTOPAlgorithm alg = new HWTOPAlgorithm(data, levels, sketchLength);
//        Algorithm rootNode = new ParallelSequentialScan(6);
        BulkInsertOperation insert = new BulkInsertOperation(data);
        alg.executeOperation(insert);

//        List<Integer> numberOfObjectsInLeaves = rootNode.getNumberOfObjectsInLeaves();
//        Tools.printCollection(numberOfObjectsInLeaves, "\n");
        alg.storeToFile("c:\\Data\\2017\\2017_11_Sketch_processing\\sketches\\decaf\\Saved_dist_comps_HWTOP\\HWTOP_" + s + "_" + levels + ".alg");
        System.exit(0);
        return alg;
    }

    private static void onLocalHost() throws FileNotFoundException, IOException, NullPointerException, ClassNotFoundException, AlgorithmMethodException, NoSuchMethodException {
        for (int k : new int[]{10, 1}) {
            for (String s : new String[]{"50_50", "75_25", "80_20"}) {
                int sketchLength = 256;

//                Algorithm alg = new ParallelSequentialScan(1);
                List<Sketch> data;
                List<Sketch> queries;

                if (!s.equals("50_50")) {
                    data = Tools.getObjects(Sketch.class
                            .getName(), "c:\\Data\\2016\\2016_Unbalanced_sketches\\Decaf\\" + s + "\\sketches\\" + sketchLength + "b.data");
                    queries = Tools.getObjects(Sketch.class.getName(), "c:\\Data\\2016\\2016_Unbalanced_sketches\\Decaf\\" + s + "\\sketches\\queries_" + sketchLength + "b.data");
                } else {
                    data = Tools.getObjects(Sketch.class
                            .getName(), "c:\\Data\\2017\\2017_11_Sketch_processing\\sketches\\decaf\\sketches\\50_50\\" + sketchLength + "b.data");
                    queries = Tools.getObjects(Sketch.class.getName(), "c:\\Data\\2017\\2017_11_Sketch_processing\\sketches\\decaf\\sketches\\50_50\\queries_" + sketchLength + "b.data");
                }
//                List<Sketch> data = Tools.getObjects(Sketch.class.getName(), "c:\\Data\\2017\\2017_11_Sketch_processing\\sketches\\cophir\\sketches\\50_50\\oriented_for_HWT\\" + sketchLength + "b.data");

//                List<Sketch> queries = Tools.getObjects(Sketch.class.getName(), "c:\\Data\\2017\\2017_11_Sketch_processing\\sketches\\cophir\\sketches\\50_50\\queries_" + sketchLength + "b.data");
//
                for (int levels = 2; levels <= 5; levels++) {
                    // pocet deleni 2 ^ (n-1)
                    System.setOut(new PrintStream("c:\\Data\\2017\\2017_11_Sketch_processing\\sketches\\decaf\\Saved_dist_comps_HWTOP\\k" + k + "\\Results_" + s + "_" + (int) Math.pow(2, levels - 1) + "_k" + k + "inf.csv"));

//                HWTOPAlgorithm alg = createAlg(data, sketchLength, levels, s);
                    int counter = 0;
                    HWTOPAlgorithm alg = (HWTOPAlgorithm) Algorithm.restoreFromFile("c:\\Data\\2017\\2017_11_Sketch_processing\\sketches\\decaf\\Saved_dist_comps_HWTOP\\HWTOP_" + s + "_" + levels + ".alg");
                    alg
                            .getOperationStatistics().getStatistics("OperationTime", StatisticTimer.class
                            ).reset();

//        Tools.printMap(alg.getTreeStructureDescription());
//        System.exit(0);
                    t1 = 0;
                    t2 = 0;
                    t3 = 0;
                    t4 = 0;
                    t5 = 0;
                    sum = 0f;
                    for (Sketch query : queries) {
//                    if (counter == 10) {
//                        break;
//                    }
                        KNNQueryOperation op = new KNNQueryOperation(query, k);
//                RangeQueryOperation op = new RangeQueryOperation(query, range);
                        alg.executeOperation(op);
                        Iterator<RankedAbstractObject> answer = op.getAnswer();
                        while (answer.hasNext()) {
                            RankedAbstractObject next = answer.next();
//                        if (next.getObject().getLocatorURI().equals(query.getLocatorURI())) {
//                            System.out.println("Achtung! The exact match on query object!");
//                        }
                        }
//            System.out.println("AAA: " + op.getAnswerDistance());
                        sum += op.getAnswerDistance();
//                    System.out.println(max);
                        System.out.println(100 - HWTOPAlgorithm.distCounts / 10000f);
                        HWTOPAlgorithm.distCounts = 0;
                        counter++;
                    }

                    System.out.println(
                            "Average range: " + (sum / counter));
                    t5 = alg.getOperationStatistics().getStatistics("OperationTime", StatisticTimer.class).get();

                    System.out.println(
                            "");
                    System.out.println(t1);

                    System.out.println(t2);

                    System.out.println(t3);

                    System.out.println(t4);

                    System.out.println(t5);

                    System.out.println(t6);
                }
            }
        }
    }

    private static void createAlg(String[] args) {
        try {
            List<Sketch> data = Tools.getObjects(Sketch.class.getName(), args[0]);
            int sketchLength = Integer.parseInt(args[1]);
            // pocet deleni 2 ^ (n-1)
            int levels = Integer.parseInt(args[2]);
            HWTOPAlgorithm alg = new HWTOPAlgorithm(data, levels, sketchLength);
            BulkInsertOperation insert = new BulkInsertOperation(data);
            alg.executeOperation(insert);
            alg.storeToFile(args[3]);
        } catch (AlgorithmMethodException | NoSuchMethodException | IOException ex) {
            Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

}
