/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sf.objects.sketchcreator.impl;

import messif.objects.LocalAbstractObject;
import sf.objects.impl.Sketch;

/**
 *
 * @author xmic
 */
public class GenHyperplaneSettingAllOnesIfMany extends GenHyperplane {

    public GenHyperplaneSettingAllOnesIfMany(String pivotFile, String objectClass, int sketchSize, String csvFileWithPivotsPairs, boolean uniquePivots) {
        super(pivotFile, objectClass, sketchSize, csvFileWithPivotsPairs, uniquePivots);
    }

    public GenHyperplaneSettingAllOnesIfMany(String pivotFile, String objectClass, int sketchSize, boolean makeAllPairs) {
        super(pivotFile, objectClass, sketchSize, makeAllPairs);
    }

    public GenHyperplaneSettingAllOnesIfMany(LocalAbstractObject[] pivots) {
        super(pivots);
    }

    @Override
    public Sketch transform(LocalAbstractObject objectToTransform) {
        Sketch ret = super.transform(objectToTransform);
        int cardinality = ret.getCardinality();
        if (cardinality >= 0.87f * pivots.length / 2) {
            for (int i = 0; i < pivots.length / 2; i++) {
                ret.setBitValuePositive(i);
            }
//        } else if (cardinality <= 0.75f * pivots.length / 2) {
//            for (int i = 0; i < pivots.length / 2; i++) {
//                ret.setBitValueNegative(i);
//            }
        }
        return ret;
    }

}
