/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sf.pivotAnalyzer.csvPivotInfoFileProcessorImpl;

import java.util.HashMap;
import java.util.Map;
import java.util.SortedMap;
import main.tools.Tools;
import messif.objects.LocalAbstractObject;
import sf.pivotAnalyzer.CsvPivotInfoFileProcessor;

/**
 *
 * @author xmic
 */
public class CsvFileVoronoiPivots extends CsvPivotInfoFileProcessor {

    private Map<String, LocalAbstractObject> pivotsMapping;

    public Map<String, LocalAbstractObject> getPivotsMapping() {
        return pivotsMapping;
    }

    public CsvFileVoronoiPivots(String csvFilePath, boolean uniquePivots, LocalAbstractObject[] pivots, String delimiter) {
        super(csvFilePath, uniquePivots, pivots, delimiter);
        SortedMap<String, String> csvMap = Tools.parseCsvMapStrings(csvFilePath);
        pivotsMapping = new HashMap<>();
        for (Map.Entry<String, String> csvLine : csvMap.entrySet()) {
            LocalAbstractObject pivot = getPivotByLocator(csvLine.getValue());
            pivotsMapping.put(csvLine.getKey(), pivot);
        }
    }

    public CsvFileVoronoiPivots(String csvFilePath, boolean uniquePivots, LocalAbstractObject[] pivots) {
        this(csvFilePath, uniquePivots, pivots, ";");
    }

    public CsvFileVoronoiPivots(String csvFilePath, LocalAbstractObject[] pivots) {
        this(csvFilePath, false, pivots);
    }

    @Override
    protected String[] processSplitLine(String[] split, int index) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

}
