///*
// * To change this license header, choose License Headers in Project Properties.
// * To change this template file, choose Tools | Templates
// * and open the template in the editor.
// */
//package sf.recallEstimation.UnivariateFunctionImpl;
//
//import java.util.HashMap;
//import java.util.Map;
//import org.apache.commons.math4.analysis.UnivariateFunction;
//import org.apache.commons.math4.distribution.BinomialDistribution;
//
///**
// *
// * @author xmic
// */
//public class PxbSmall implements UnivariateFunction {
//
//    private final BinomialDistribution binomial;
//    private final Double iDim;
//    private double[] p;
//    private double[] q;
//
//    public PxbSmall(int bSkLength, Double iDim, double pxProbSkBitsDifX) {
//        binomial = new BinomialDistribution(bSkLength, pxProbSkBitsDifX);
//        this.iDim = iDim;
////        initArraysPQ(pxProbSkBitsDifX);
//    }
//
//    public PxbSmall(int bSkLength, Double iDim, UnivariateFunction pxProbSkBitsDif, double x) {
//        this(bSkLength, iDim, pxProbSkBitsDif.value(x));
//    }
//
//    @Override
//    public double value(double bBitIndexDouble) {
//        if (bBitIndexDouble > binomial.getNumberOfTrials()) {
//            return 0;
//        }
//        int bBitIndex = (int) Math.round(bBitIndexDouble);
//        return binomial.probability(bBitIndex);
//    }
//
//    private void initArraysPQ(double prob) {
//        if (iDim == null) {
//            p = null;
//            q = null;
//            return;
//        }
//        int numberOfTrials = binomial.getNumberOfTrials();
//        double c2 = (numberOfTrials - 2 * iDim) / (2 * iDim * (numberOfTrials - 1));
//        double pom = prob * (1 / 4d - Math.pow(c2 - 0.5, 2));
//        p = new double[3];
//        q = new double[3];
//        p[0] = Math.max(prob - pom, 0);
//        p[1] = Math.max(prob - pom, 0);
//        p[2] = Math.max(prob - pom, 0);
////        p[0] = Math.min(prob + pom, 1);
////        p[1] = Math.min(prob + pom, 1);
////        p[2] = Math.min(prob + pom, 1);
//        for (int i = 0; i < 3; i++) {
//            q[i] = 1 - p[i];
//        }
//        for (int i = 0; i < 3; i++) {
//            if (p[i] > 1 || p[i] < 0) {
//                throw new Error("Pi" + p[i] + ", i: " + i);
//            }
//            if (q[i] > 1 || q[i] < 0) {
//                throw new Error("Pi" + p[i] + ", i: " + i);
//            }
//        }
//    }
//
////    @Override
////    public double probability(int x) {
////        if (iDim == null) {
////            return super.probability(x);
////        }
//////        double ret = super.probability(x);
////        double ret = fXnX(getNumberOfTrials(), x);
//////        if (Math.abs(r1 - ret) > 1E-3) {
//////            System.out.println("(" + getNumberOfTrials() + ", " + x + ") prob: " + getProbabilityOfSuccess());
//////            System.out.println(r1 + ", " + ret);
//////            System.out.println("");
//////        }
////        return ret;
////    }
//    private static final Map<String, Double> cache = new HashMap<>();
//
//    private double fXnX(int n, int x) {
//        if (x == 0 && n == 0) {
//            return 1;
//        }
//        if (x > n) {
//            return 0;
//        }
//        String key = Integer.toString(x) + Integer.toString(n) + Double.toString(iDim);
//        for (int i = 0; i < 3; i++) {
//            key += Double.toString(p[i]);
//        }
//        synchronized (cache) {
//            if (cache.containsKey(key)) {
//                return cache.get(key);
//            }
//        }
//        if (x == 0) {
//            double ret = q[0] * Math.pow(q[2], n - 1);
//            synchronized (cache) {
//                cache.put(key, ret);
//            }
//            return ret;
//        }
//        synchronized (cache) {
//            if (cache.size() > 1000000) {
//                cache.clear();
//            }
//        }
//        double ret = q[2] * fXnX(n - 1, x) + p[1] * fXnX(n - 1, x - 1) + (p[2] - p[1]) * fXnX(n - 2, x - 1);
//        synchronized (cache) {
//            cache.put(key, ret);
//        }
//        return ret;
//    }
//
//}
