/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sf.recallEstimation.pxEvaluator;

import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.SortedMap;
import java.util.logging.Level;
import java.util.logging.Logger;
import messif.objects.impl.ObjectFloatVectorNeuralNetworkL2;

/**
 *
 * @author xmic
 */
public class TestPxEvaluator {

    // cophir
//    public static final String className = MetaObjectSAPIRWeightedDist3.class.getName();
//    public static final String pivotFile = "c:\\Data\\2015_Doktorske\\Desc\\cophir\\mpeg7\\pivots-2560-random.data";
//    public static final Integer sketchSize = 160;
//    public static final String csvFileWithPivotsPairs = "c:\\Data\\2016\\2016_Recall_Estimation\\Cophir_MPEG7\\pivots_filtered_hyperplane\\UncorrelatedPivots_" + sketchSize + "_pairs.csv";
//    public static final String queriesFile = "c:\\Data\\2015_Doktorske\\Desc\\cophir\\mpeg7\\queryset-cophir-1000.data";
//    public static final String sampleFile = "c:\\Data\\2015_Doktorske\\Desc\\cophir\\mpeg7\\100K\\metaobject.data";
//    public static final String outputFile = "c:\\Data\\2016\\2016_Recall_Estimation\\Cophir_MPEG7\\Probabilities_that_bit_differs\\res_" + sketchSize + "b_10K_objects.csv";
//    public static final double distInterval = 0.1d;
//    public static final double maxDist = 6d;
//    public static final Integer objectCount = 10000;
    // profiset
    public static final String className = ObjectFloatVectorNeuralNetworkL2.class.getName();
    public static final String pivotFile = "c:\\Data\\2015_Doktorske\\Desc\\profiset\\caffe\\pivots-random-2560.data";
//    public static final String pivotFile = "c:\\Data\\2015_Doktorske\\Desc\\profiset\\caffe\\pivots-outliers-2560.data";
//    public static final Integer sketchSize = 256;
    public static final Integer sketchSize = 60;
    public static final String csvFileWithPivotsPairs = "c:\\Data\\2016\\2016_Unbalanced_sketches\\Decaf\\80_20\\pivots\\PivotsCorrelatedTo-0.25_length_256_pairs.csv";
//    public static final String csvFileWithPivotsPairs = "c:\\Data\\2017\\2017_Voronoi_Sketches\\shuffle_pivots\\0_Pivots_100000obj_512p.txt";
//    public static final String csvFileWithPivotsPairs = "c:\\Data\\2017\\2017_Voronoi_Sketches\\px_evaluations\\01_Pivots_100000obj_512p.txt";
//    public static final String[] csvFiles = new String[]{
//        "c:\\Data\\2017\\2017_Voronoi_Sketches\\shuffle_pivots\\0_Pivots_100000obj_512p.txt",
//        "c:\\Data\\2017\\2017_Voronoi_Sketches\\shuffle_pivots\\1_Pivots_100000obj_512p.txt",
//        "c:\\Data\\2017\\2017_Voronoi_Sketches\\shuffle_pivots\\2_Pivots_100000obj_512p.txt",
//        "c:\\Data\\2017\\2017_Voronoi_Sketches\\shuffle_pivots\\3_Pivots_100000obj_512p.txt"
//    };
    public static final String queriesFile = "c:\\Data\\2015_Doktorske\\Desc\\profiset\\caffe\\profi-neuralnet-1000-query.data";
    public static final String sampleFile = "c:\\Data\\2015_Doktorske\\Desc\\profiset\\caffe\\profi-neuralnet-100K.data.gz";
//    public static final String outputFile = "c:\\Data\\2017\\px_evaluations\\Profiset\\Pokusy\\Mix\\0.87_res_" + sketchSize + "b_uncorr_10K_objects.csv";
    public static final String outputFile = "c:\\Data\\2017\\2017_Voronoi_Sketches\\px_evaluations\\px_sketches100K_pivots_100000obj_512p.csv";
    public static final Integer distInterval = 2;
    public static final Integer maxDist = 210;
    public static final Integer objectCount = 10000;
//

    public static void main(String[] args) {
        PxEvaluator probEvaluator = new PxEvaluator(className, pivotFile, csvFileWithPivotsPairs, sketchSize, queriesFile, sampleFile, distInterval, maxDist, objectCount, 20);
        SortedMap<Float, Float> probs = probEvaluator.evaluateProbabilities();
//        float[] avgHamDistDistr = probEvaluator.evaluateAvgHamDistDistr();
        try {
            System.setOut(new PrintStream(outputFile));
        } catch (FileNotFoundException ex) {
            Logger.getLogger(TestPxEvaluator.class.getName()).log(Level.SEVERE, null, ex);
        }
        probEvaluator.printProbabilities(probs, distInterval, maxDist);
//        probEvaluator.printProbsMeansSigmas(probs, avgHamDistDistr);
//        SortedMap<Float, Float> parse = PxEvaluator.parse("c:\\Data\\2016\\2016_Recall\\Probabilities_that_bit_differs\\res_10K_objects_average.csv");
    }

}
