/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sf.pivotAnalyzer.csvPivotInfoFileProcessorImpl;

import java.util.Arrays;
import messif.objects.LocalAbstractObject;
import sf.pivotAnalyzer.CsvPivotInfoFileProcessor;

/**
 *
 * @author Matej Kvassay <www.matejkvassay.sk>
 */
public class CsvFileBandRanges extends CsvPivotInfoFileProcessor {

    private float[] ranges1;
    private float[] ranges2;

    public CsvFileBandRanges(String csvFilePath, LocalAbstractObject[] pivots, float[] ranges1, float[] ranges2, String delimiter) {
        super(csvFilePath, false, pivots, delimiter);
        this.ranges1 = ranges1;
        this.ranges2 = ranges2;
        Arrays.fill(ranges1, -1);
        Arrays.fill(ranges2, -1);
    }

    public CsvFileBandRanges(String csvFilePath, LocalAbstractObject[] pivots, float[] ranges1, float[] ranges2) {
        this(csvFilePath, pivots, ranges1, ranges2, ";");
    }

    @Override
    protected String[] processSplitLine(String[] split, int index) {
        ranges1[index] = Float.parseFloat(removeQutes(split[1]));
        ranges2[index] = Float.parseFloat(removeQutes(split[2]));
        return new String[]{split[0]};
    }
}
